part of twilio_unofficial_programmable_video;

/// Twilio Video SDK Exception.
class TwilioException implements Exception {
  static final int ACCESS_TOKEN_INVALID_EXCEPTION = 20101;
  static final int ACCESS_TOKEN_HEADER_INVALID_EXCEPTION = 20102;
  static final int ACCESS_TOKEN_ISSUER_INVALID_EXCEPTION = 20103;
  static final int ACCESS_TOKEN_EXPIRED_EXCEPTION = 20104;
  static final int ACCESS_TOKEN_NOT_YET_VALID_EXCEPTION = 20105;
  static final int ACCESS_TOKEN_GRANTS_INVALID_EXCEPTION = 20106;
  static final int ACCESS_TOKEN_SIGNATURE_INVALID_EXCEPTION = 20107;
  static final int SIGNALING_CONNECTION_ERROR_EXCEPTION = 53000;
  static final int SIGNALING_CONNECTION_DISCONNECTED_EXCEPTION = 53001;
  static final int SIGNALING_CONNECTION_TIMEOUT_EXCEPTION = 53002;
  static final int SIGNALING_INCOMING_MESSAGE_INVALID_EXCEPTION = 53003;
  static final int SIGNALING_OUTGOING_MESSAGE_INVALID_EXCEPTION = 53004;
  static final int SIGNALING_DNS_RESOLUTION_ERROR_EXCEPTION = 53005;
  static final int ROOM_NAME_INVALID_EXCEPTION = 53100;
  static final int ROOM_NAME_TOO_LONG_EXCEPTION = 53101;
  static final int ROOM_NAME_CHARS_INVALID_EXCEPTION = 53102;
  static final int ROOM_CREATE_FAILED_EXCEPTION = 53103;
  static final int ROOM_CONNECT_FAILED_EXCEPTION = 53104;
  static final int ROOM_MAX_PARTICIPANTS_EXCEEDED_EXCEPTION = 53105;
  static final int ROOM_NOT_FOUND_EXCEPTION = 53106;
  static final int ROOM_MAX_PARTICIPANTS_OUT_OF_RANGE_EXCEPTION = 53107;
  static final int ROOM_TYPE_INVALID_EXCEPTION = 53108;
  static final int ROOM_TIMEOUT_OUT_OF_RANGE_EXCEPTION = 53109;
  static final int ROOM_STATUS_CALLBACK_METHOD_INVALID_EXCEPTION = 53110;
  static final int ROOM_STATUS_CALLBACK_INVALID_EXCEPTION = 53111;
  static final int ROOM_STATUS_INVALID_EXCEPTION = 53112;
  static final int ROOM_ROOM_EXISTS_EXCEPTION = 53113;
  static final int ROOM_INVALID_PARAMETERS_EXCEPTION = 53114;
  static final int ROOM_MEDIA_REGION_INVALID_EXCEPTION = 53115;
  static final int ROOM_MEDIA_REGION_UNAVAILABLE_EXCEPTION = 53116;
  static final int ROOM_SUBSCRIPTION_OPERATION_NOT_SUPPORTED_EXCEPTION = 53117;
  static final int ROOM_ROOM_COMPLETED_EXCEPTION = 53118;
  static final int PARTICIPANT_IDENTITY_INVALID_EXCEPTION = 53200;
  static final int PARTICIPANT_IDENTITY_TOO_LONG_EXCEPTION = 53201;
  static final int PARTICIPANT_IDENTITY_CHARS_INVALID_EXCEPTION = 53202;
  static final int PARTICIPANT_MAX_TRACKS_EXCEEDED_EXCEPTION = 53203;
  static final int PARTICIPANT_NOT_FOUND_EXCEPTION = 53204;
  static final int PARTICIPANT_DUPLICATE_IDENTITY_EXCEPTION = 53205;
  static final int TRACK_INVALID_EXCEPTION = 53300;
  static final int TRACK_NAME_INVALID_EXCEPTION = 53301;
  static final int TRACK_NAME_TOO_LONG_EXCEPTION = 53302;
  static final int TRACK_NAME_CHARS_INVALID_EXCEPTION = 53303;
  static final int TRACK_NAME_IS_DUPLICATED_EXCEPTION = 53304;
  static final int TRACK_SERVER_TRACK_CAPACITY_REACHED_EXCEPTION = 53305;
  static final int MEDIA_CLIENT_LOCAL_DESC_FAILED_EXCEPTION = 53400;
  static final int MEDIA_SERVER_LOCAL_DESC_FAILED_EXCEPTION = 53401;
  static final int MEDIA_CLIENT_REMOTE_DESC_FAILED_EXCEPTION = 53402;
  static final int MEDIA_SERVER_REMOTE_DESC_FAILED_EXCEPTION = 53403;
  static final int MEDIA_NO_SUPPORTED_CODEC_EXCEPTION = 53404;
  static final int MEDIA_CONNECTION_ERROR_EXCEPTION = 53405;
  static final int CONFIGURATION_ACQUIRE_FAILED_EXCEPTION = 53500;
  static final int CONFIGURATION_ACQUIRE_TURN_FAILED_EXCEPTION = 53501;

  /// Code indicator, should match any of the [TwilioException] static properties.
  final int code;

  /// Message containing a short explanation.
  final String message;

  TwilioException(this.code, this.message);

  @override
  String toString() {
    return 'TwilioException: code: $code, message: $message';
  }
}
